Index: code/branches/map/src/orxonox/overlays/CMakeLists.txt
===================================================================
--- code/branches/map/src/orxonox/overlays/CMakeLists.txt	(revision 2812)
+++ code/branches/map/src/orxonox/overlays/CMakeLists.txt	(revision 2837)
@@ -8,4 +8,5 @@
 ADD_SUBDIRECTORY(debug)
 ADD_SUBDIRECTORY(hud)
+ADD_SUBDIRECTORY(map)
 ADD_SUBDIRECTORY(notifications)
 ADD_SUBDIRECTORY(stats)
Index: code/branches/map/src/orxonox/overlays/map/CMakeLists.txt
===================================================================
--- code/branches/map/src/orxonox/overlays/map/CMakeLists.txt	(revision 2837)
+++ code/branches/map/src/orxonox/overlays/map/CMakeLists.txt	(revision 2837)
@@ -0,0 +1,3 @@
+ADD_SOURCE_FILES(ORXONOX_SRC_FILES
+  Map.cc
+)
Index: code/branches/map/src/orxonox/overlays/map/Map.cc
===================================================================
--- code/branches/map/src/orxonox/overlays/map/Map.cc	(revision 2837)
+++ code/branches/map/src/orxonox/overlays/map/Map.cc	(revision 2837)
@@ -0,0 +1,69 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Si Sun
+ *
+ */
+#include "OrxonoxStableHeaders.h"
+#include "Map.h"
+ 
+#include <string>
+#include <OgreOverlay.h>
+#include <OgreOverlayElement.h>
+#include <OgreOverlayManager.h>
+#include <OgreOverlayContainer.h>
+#include "core/CoreIncludes.h"
+#include "core/ConfigValueIncludes.h"
+#include "core/ConsoleCommand.h"
+#include "objects/Scene.h"
+ 
+ namespace orxonox
+ {
+    CreateFactory(Map);
+     SetConsoleCommand(Map, openMap, true);
+    
+    Map::Map(BaseObject* creator) : OrxonoxOverlay(creator)
+    {
+        RegisterObject(Map);
+        
+        //COUT(0) << "Map loaded\n" << this->getScene();
+        Ogre::SceneManager* sm = this->getScene()->getSceneManager();
+        Ogre::SceneNode* sn = new Ogre::SceneNode(sm);
+        COUT(0) << "Map loaded\n" << sm << " / " << sn << std::endl;
+    }
+    
+    void Map::XMLPort(Element& xmlElement, XMLPort::Mode mode)
+    {
+        SUPER(Map, XMLPort, xmlElement, mode);
+    }
+    
+    void Map::changedVisibility()
+    {
+        SUPER(Map, changedVisibility);
+        
+    }
+    
+    void Map::tick(float dt)
+    {
+    }
+    
+ }
Index: code/branches/map/src/orxonox/overlays/map/Map.h
===================================================================
--- code/branches/map/src/orxonox/overlays/map/Map.h	(revision 2837)
+++ code/branches/map/src/orxonox/overlays/map/Map.h	(revision 2837)
@@ -0,0 +1,69 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Si Sun
+ *
+ */
+
+#ifndef _MAP_H__
+#define _MAP_H__
+
+
+#include "OrxonoxPrereqs.h"
+#include <OgrePrerequisites.h>
+
+#include <OgreBorderPanelOverlayElement.h>
+#include <OgreTextAreaOverlayElement.h>
+
+#include "overlays/OrxonoxOverlay.h"
+#include "objects/Tickable.h"
+
+
+namespace orxonox
+{
+    class _OrxonoxExport Map : public OrxonoxOverlay, public Tickable
+    {
+
+    public: // functions
+        Map(BaseObject* creator);
+        virtual ~Map() {}
+
+        virtual void XMLPort(Element& xmlElement, XMLPort::Mode mode);
+        virtual void tick(float dt);
+
+        virtual void changedVisibility();
+        
+        inline static void openMap()
+            {
+                COUT(0) << "Opening Map";
+            }
+        
+    private: // functions
+
+
+    private: // variables
+
+
+    };
+}
+
+#endif /* _MAP_H__ */